#!/bin/sh -f

# cat CLASS_UUP*       | grep -v '[=_]' > uup_probs
# cat CLASS_[GH]?[SP]* | grep -v '[=_]' | grep + > feq_probs
# cat CLASS_[GH]?[N]*  | grep -v '[=_]' | grep + > fne_probs
# cat CLASS_[GH]?[SP]* | grep -v '[=_]' | grep -v + > ceq_probs
# cat CLASS_[GH]?[N]*  | grep -v '[=_]' | grep -v + > cne_probs

# cat CLASS_UH[SP]* | grep -v '[=_]' | grep + >> feq_probs
# cat CLASS_UHN*    | grep -v '[=_]' | grep + >> fne_probs
# cat CLASS_UH[SP]* | grep -v '[=_]' | grep -v + >> ceq_probs
# cat CLASS_UHN*    | grep -v '[=_]' | grep -v + >> cne_probs

# cat CLASS_UUS* | grep -v '[=_]' | grep + >> feq_probs
# cat CLASS_UUN* | grep -v '[=_]' | grep + >> fne_probs
# cat CLASS_UUS* | grep -v '[=_]' | grep -v + >> ceq_probs
# cat CLASS_UUN* | grep -v '[=_]' | grep -v + >> cne_probs

function single_val ( )
{
   printf " & %5d" `filter_results.awk $2 $1 | eauswert.awk | cut -d: -f3|cut -d/ -f1`
}

function single_val_em ( )
{
   printf " & \\\\emph{%5d}" `filter_results.awk $2 $1 | eauswert.awk | cut -d: -f3|cut -d/ -f1`
}



function single_line ( )
{
    printf "%-45s" "$1"
    single_val $2 uup_probs
    single_val $2 cne_probs
    single_val $2 ceq_probs
    single_val $2 fne_probs
    single_val $2 feq_probs
    single_val $2 $2
    printf " \\\\\\\\ \n"
}

function single_line_em ( )
{
    printf "\\\\emph{%-30s}" "$1"
    single_val_em $2 uup_probs
    single_val_em $2 cne_probs
    single_val_em $2 ceq_probs
    single_val_em $2 fne_probs
    single_val_em $2 feq_probs
    single_val_em $2 $2
    printf " \\\\\\\\ \n"
}


function single_size ( )
{
   printf " & {\\\\tiny (%d)}" `wc $1|gawk '{print $1}'`
}


function size_line ( )
{
    printf "%-45s" "{\\tiny Class size}"
    single_size uup_probs
    single_size cne_probs
    single_size ceq_probs
    single_size fne_probs
    single_size feq_probs
    single_size all_probs_list
    echo "\\\\\\\\"
}

function wrap_header ( )
{
    printf "& \\\\multicolumn{1}{p{4em}}{\\\\hfill{}\\\\textbf{$1}}"
}


grep " T " protocol_default.csv > protocol_default_prf.csv
grep " N " protocol_default.csv > protocol_default_cst.csv

grep " T " protocol_auto.csv > protocol_auto_prf.csv
grep " N " protocol_auto.csv > protocol_auto_cst.csv


echo "\\\\begin{tabular}{lrrrrrr}"
echo "\\\\hline"
printf "\\\\textbf{Strategy} "
wrap_header "UEQ"
echo
wrap_header "CNE"
wrap_header "CEQ"
echo
wrap_header "FNE"
wrap_header "FEQ"
echo
wrap_header "All"
printf "\\\\\\\\"
echo
size_line
echo "\\\\hline"
single_line "Best (all)"           protocol_default.csv
single_line "Best (proofs)"        protocol_default_prf.csv
single_line "Best (sat)"           protocol_default_cst.csv
echo "\\\\hline"
single_line "No indexing"          protocol_default_ni.csv
single_line "No subsumption"       protocol_nosub.csv
single_line "Forward sub.\ only"   protocol_deffs.csv
single_line "Backward sub.\ only"  protocol_defbs.csv
single_line "No literal selection" protocol_nosel.csv
#single_line "Select smalles lit."  protocol_smallsel.csv
#single_line "Symbol count only"    protocol_symcount.csv
echo "\\\\hline"
single_line "E 2.4 auto (all)"     protocol_auto.csv
single_line "E 2.4 auto (proofs)"  protocol_auto_prf.csv
single_line "E 2.4 auto (sat)"     protocol_auto_cst.csv
echo "\\\\hline"
echo "\\\\end{tabular}"
